diff --git a/lib/anacondatest.pm b/lib/anacondatest.pm
--- a/lib/anacondatest.pm
+++ b/lib/anacondatest.pm
@@ -128,6 +128,8 @@
     my ($self, $fs, $part) = @_;
     $part ||= "root";
     assert_and_click "anaconda_part_select_$part";
+    # if fs is already set correctly, do nothing
+    return if (check_screen "anaconda_part_fs_${fs}_selected", 5);
     assert_and_click "anaconda_part_fs";
     # Move the mouse away from the menu
     mouse_set(10, 10);
diff --git a/needles/anaconda/package_selection/french/minimal_highlighted_french-custom.json b/needles/anaconda/package_selection/french/minimal_highlighted_french-custom.json
new file mode 100644
--- /dev/null
+++ b/needles/anaconda/package_selection/french/minimal_highlighted_french-custom.json
@@ -0,0 +1,18 @@
+{
+    "area": [
+        {
+            "height": 17,
+            "type": "match",
+            "width": 268,
+            "xpos": 48,
+            "ypos": 177
+        }
+    ],
+    "properties": [],
+    "tags": [
+        "anaconda_minimal_highlighted",
+        "ENV-DISTRI-fedora",
+        "LANGUAGE-french",
+        "ENV-FLAVOR-server"
+    ]
+}
diff --git a/needles/anaconda/package_selection/french/minimal_highlighted_french-custom.png b/needles/anaconda/package_selection/french/minimal_highlighted_french-custom.png
new file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/package_selection/french/minimal_selected_french-custom.json b/needles/anaconda/package_selection/french/minimal_selected_french-custom.json
new file mode 100644
--- /dev/null
+++ b/needles/anaconda/package_selection/french/minimal_selected_french-custom.json
@@ -0,0 +1,18 @@
+{
+    "area": [
+        {
+            "height": 16,
+            "type": "match",
+            "width": 162,
+            "xpos": 28,
+            "ypos": 177
+        }
+    ],
+    "properties": [],
+    "tags": [
+        "anaconda_minimal_selected",
+        "ENV-DISTRI-fedora",
+        "LANGUAGE-french",
+        "ENV-FLAVOR-server"
+    ]
+}
diff --git a/needles/anaconda/package_selection/french/minimal_selected_french-custom.png b/needles/anaconda/package_selection/french/minimal_selected_french-custom.png
new file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/package_selection/minimal_highlighted-custom.json b/needles/anaconda/package_selection/minimal_highlighted-custom.json
new file mode 100644
--- /dev/null
+++ b/needles/anaconda/package_selection/minimal_highlighted-custom.json
@@ -0,0 +1,18 @@
+{
+    "area": [
+        {
+            "height": 15,
+            "type": "match",
+            "width": 94,
+            "xpos": 48,
+            "ypos": 177
+        }
+    ],
+    "properties": [],
+    "tags": [
+        "anaconda_minimal_highlighted",
+        "ENV-DISTRI-fedora",
+        "LANGUAGE-english",
+        "ENV-FLAVOR-server"
+    ]
+}
\ No newline at end of file
diff --git a/needles/anaconda/package_selection/minimal_highlighted-custom.png b/needles/anaconda/package_selection/minimal_highlighted-custom.png
new file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/package_selection/minimal_selected-custom.json b/needles/anaconda/package_selection/minimal_selected-custom.json
new file mode 100644
--- /dev/null
+++ b/needles/anaconda/package_selection/minimal_selected-custom.json
@@ -0,0 +1,18 @@
+{
+    "area": [
+        {
+            "height": 14,
+            "type": "match",
+            "width": 114,
+            "xpos": 28,
+            "ypos": 177
+        }
+    ],
+    "properties": [],
+    "tags": [
+        "anaconda_minimal_selected",
+        "ENV-DISTRI-fedora",
+        "LANGUAGE-english",
+        "ENV-FLAVOR-server"
+    ]
+}
\ No newline at end of file
diff --git a/needles/anaconda/package_selection/minimal_selected-custom.png b/needles/anaconda/package_selection/minimal_selected-custom.png
new file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/package_selection/russian/minimal_highlighted_russian-custom.json b/needles/anaconda/package_selection/russian/minimal_highlighted_russian-custom.json
new file mode 100644
--- /dev/null
+++ b/needles/anaconda/package_selection/russian/minimal_highlighted_russian-custom.json
@@ -0,0 +1,16 @@
+{
+  "tags": [
+    "LANGUAGE-russian",
+    "anaconda_minimal_highlighted"
+  ],
+  "properties": [],
+  "area": [
+    {
+      "xpos": 48,
+      "type": "match",
+      "height": 15,
+      "ypos": 179,
+      "width": 294
+    }
+  ]
+}
\ No newline at end of file
diff --git a/needles/anaconda/package_selection/russian/minimal_highlighted_russian-custom.png b/needles/anaconda/package_selection/russian/minimal_highlighted_russian-custom.png
new file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/package_selection/russian/minimal_selected_russian-custom.json b/needles/anaconda/package_selection/russian/minimal_selected_russian-custom.json
new file mode 100644
--- /dev/null
+++ b/needles/anaconda/package_selection/russian/minimal_selected_russian-custom.json
@@ -0,0 +1,16 @@
+{
+  "area": [
+    {
+      "height": 15,
+      "type": "match",
+      "xpos": 31,
+      "width": 310,
+      "ypos": 179
+    }
+  ],
+  "properties": [],
+  "tags": [
+    "LANGUAGE-russian",
+    "anaconda_minimal_selected"
+  ]
+}
\ No newline at end of file
diff --git a/needles/anaconda/package_selection/russian/minimal_selected_russian-custom.png b/needles/anaconda/package_selection/russian/minimal_selected_russian-custom.png
new file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected-cantarell17.json b/needles/anaconda/partitioning/fs_ext4_preselected-cantarell17.json
deleted file mode 100644
--- a/needles/anaconda/partitioning/fs_ext4_preselected-cantarell17.json
+++ /dev/null
@@ -1,17 +0,0 @@
-{
-  "properties": [],
-  "area": [
-    {
-      "height": 56,
-      "ypos": 336,
-      "width": 79,
-      "type": "match",
-      "xpos": 371
-    }
-  ],
-  "tags": [
-    "anaconda_part_fs",
-    "ENV-DISTRI-fedora",
-    "ENV-FLAVOR-server"
-  ]
-}
\ No newline at end of file
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected-cantarell17.png b/needles/anaconda/partitioning/fs_ext4_preselected-cantarell17.png
deleted file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected-cantarell18.json b/needles/anaconda/partitioning/fs_ext4_preselected-cantarell18.json
deleted file mode 100644
--- a/needles/anaconda/partitioning/fs_ext4_preselected-cantarell18.json
+++ /dev/null
@@ -1,17 +0,0 @@
-{
-  "tags": [
-    "anaconda_part_fs",
-    "ENV-DISTRI-fedora",
-    "ENV-FLAVOR-server"
-  ],
-  "properties": [],
-  "area": [
-    {
-      "height": 56,
-      "ypos": 336,
-      "type": "match",
-      "xpos": 372,
-      "width": 79
-    }
-  ]
-}
\ No newline at end of file
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected-cantarell18.png b/needles/anaconda/partitioning/fs_ext4_preselected-cantarell18.png
deleted file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected-cantarell20.json b/needles/anaconda/partitioning/fs_ext4_preselected-cantarell20.json
deleted file mode 100644
--- a/needles/anaconda/partitioning/fs_ext4_preselected-cantarell20.json
+++ /dev/null
@@ -1,17 +0,0 @@
-{
-  "properties": [],
-  "area": [
-    {
-      "ypos": 348,
-      "type": "match",
-      "height": 56,
-      "xpos": 372,
-      "width": 79
-    }
-  ],
-  "tags": [
-    "anaconda_part_fs",
-    "ENV-DISTRI-fedora",
-    "ENV-FLAVOR-server"
-  ]
-}
\ No newline at end of file
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected-cantarell20.png b/needles/anaconda/partitioning/fs_ext4_preselected-cantarell20.png
deleted file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected-freetype262.json b/needles/anaconda/partitioning/fs_ext4_preselected-freetype262.json
deleted file mode 100644
--- a/needles/anaconda/partitioning/fs_ext4_preselected-freetype262.json
+++ /dev/null
@@ -1,17 +0,0 @@
-{
-  "area": [
-    {
-      "xpos": 372,
-      "width": 79,
-      "ypos": 336,
-      "height": 56,
-      "type": "match"
-    }
-  ],
-  "properties": [],
-  "tags": [
-    "anaconda_part_fs",
-    "ENV-DISTRI-fedora",
-    "ENV-FLAVOR-server"
-  ]
-}
\ No newline at end of file
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected-freetype262.png b/needles/anaconda/partitioning/fs_ext4_preselected-freetype262.png
deleted file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected-gtk3195.json b/needles/anaconda/partitioning/fs_ext4_preselected-gtk3195.json
deleted file mode 100644
--- a/needles/anaconda/partitioning/fs_ext4_preselected-gtk3195.json
+++ /dev/null
@@ -1,17 +0,0 @@
-{
-  "properties": [],
-  "tags": [
-    "anaconda_part_fs",
-    "ENV-DISTRI-fedora",
-    "ENV-FLAVOR-server"
-  ],
-  "area": [
-    {
-      "type": "match",
-      "height": 56,
-      "ypos": 336,
-      "width": 79,
-      "xpos": 372
-    }
-  ]
-}
\ No newline at end of file
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected-gtk3195.png b/needles/anaconda/partitioning/fs_ext4_preselected-gtk3195.png
deleted file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected-gtk3197bug.png b/needles/anaconda/partitioning/fs_ext4_preselected-gtk3197bug.png
deleted file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected-gtk3199.json b/needles/anaconda/partitioning/fs_ext4_preselected-gtk3199.json
--- a/needles/anaconda/partitioning/fs_ext4_preselected-gtk3199.json
+++ b/needles/anaconda/partitioning/fs_ext4_preselected-gtk3199.json
@@ -1,6 +1,7 @@
 {
   "tags": [
     "anaconda_part_fs",
+    "anaconda_part_fs_ext4_selected",
     "ENV-DISTRI-fedora",
     "ENV-FLAVOR-server"
   ],
@@ -14,4 +15,4 @@
     }
   ],
   "properties": []
-}
\ No newline at end of file
+}
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected.json b/needles/anaconda/partitioning/fs_ext4_preselected.json
deleted file mode 100644
--- a/needles/anaconda/partitioning/fs_ext4_preselected.json
+++ /dev/null
@@ -1,16 +0,0 @@
-{
-    "area": [
-        {
-            "height": 56,
-            "type": "match",
-            "width": 79,
-            "xpos": 371,
-            "ypos": 356
-        }
-    ],
-    "tags": [
-        "anaconda_part_fs",
-        "ENV-DISTRI-fedora",
-        "ENV-FLAVOR-server"
-    ]
-}
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected.png b/needles/anaconda/partitioning/fs_ext4_preselected.png
deleted file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/partitioning/fs_xfs_preselected-cantarell172.json b/needles/anaconda/partitioning/fs_xfs_preselected-cantarell172.json
deleted file mode 100644
--- a/needles/anaconda/partitioning/fs_xfs_preselected-cantarell172.json
+++ /dev/null
@@ -1,17 +0,0 @@
-{
-  "area": [
-    {
-      "ypos": 336,
-      "type": "match",
-      "height": 56,
-      "width": 79,
-      "xpos": 371
-    }
-  ],
-  "tags": [
-    "anaconda_part_fs",
-    "ENV-DISTRI-fedora",
-    "ENV-FLAVOR-server"
-  ],
-  "properties": []
-}
\ No newline at end of file
diff --git a/needles/anaconda/partitioning/fs_xfs_preselected-cantarell172.png b/needles/anaconda/partitioning/fs_xfs_preselected-cantarell172.png
deleted file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/partitioning/fs_ext4_preselected-gtk3197bug.json b/needles/anaconda/partitioning/fs_xfs_preselected-gtk320.json
rename from needles/anaconda/partitioning/fs_ext4_preselected-gtk3197bug.json
rename to needles/anaconda/partitioning/fs_xfs_preselected-gtk320.json
--- a/needles/anaconda/partitioning/fs_ext4_preselected-gtk3197bug.json
+++ b/needles/anaconda/partitioning/fs_xfs_preselected-gtk320.json
@@ -1,17 +1,18 @@
 {
   "tags": [
     "anaconda_part_fs",
+    "anaconda_part_fs_xfs_selected",
     "ENV-DISTRI-fedora",
     "ENV-FLAVOR-server"
   ],
   "area": [
     {
       "ypos": 348,
-      "height": 56,
+      "width": 79,
+      "xpos": 372,
       "type": "match",
-      "xpos": 376,
-      "width": 73
+      "height": 56
     }
   ],
   "properties": []
-}
\ No newline at end of file
+}
diff --git a/needles/anaconda/partitioning/fs_xfs_preselected-gtk320.png b/needles/anaconda/partitioning/fs_xfs_preselected-gtk320.png
new file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/needles/anaconda/partitioning/fs_xfs_preselected.json b/needles/anaconda/partitioning/fs_xfs_preselected.json
deleted file mode 100644
--- a/needles/anaconda/partitioning/fs_xfs_preselected.json
+++ /dev/null
@@ -1,16 +0,0 @@
-{
-    "area": [
-        {
-            "height": 56,
-            "type": "match",
-            "width": 79,
-            "xpos": 371,
-            "ypos": 356
-        }
-    ],
-    "tags": [
-        "anaconda_part_fs",
-        "ENV-DISTRI-fedora",
-        "ENV-FLAVOR-server"
-    ]
-}
diff --git a/needles/anaconda/partitioning/fs_xfs_preselected.png b/needles/anaconda/partitioning/fs_xfs_preselected.png
deleted file mode 100644
index 0000000000000000000000000000000000000000..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/templates b/templates
--- a/templates
+++ b/templates
@@ -1533,6 +1533,7 @@
                       settings => [
                         { key => "DESKTOP", value => "kde" },
                         { key => "PACKAGE_SET", value => "kde" },
+                        { key => "REPOSITORY_VARIATION", value => "http://dl.fedoraproject.org/pub/fedora/linux/development" },
                         { key => "USER_LOGIN", value => "false" },
                       ],
                     },