diff --git a/libtaskotron.spec b/libtaskotron.spec
--- a/libtaskotron.spec
+++ b/libtaskotron.spec
@@ -1,15 +1,11 @@
-# sitelib for noarch packages, sitearch for others (remove the unneeded one)
-%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
-%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
-
 Name:           libtaskotron
 Version:        0.4.13
-Release:        1%{?dist}
+Release:        3%{?dist}
 Summary:        Taskotron Support Library
 
 License:        GPLv3
 URL:            https://bitbucket.org/fedoraqa/libtaskotron
-Source0:        http://qadevel.fedoraproject.org/releases/%{name}/%{name}-%{version}.tar.gz
+Source0:        https://qadevel.cloud.fedoraproject.org/releases/%{name}/%{name}-%{version}.tar.gz
 
 BuildArch:      noarch
 
@@ -20,30 +16,31 @@
 Requires:       libtaskotron-disposable = %{version}-%{release}
 
 %description
-Libtaskotron is a support library for running taskotron tasks. The top level libtaskotron package is a meta-package which will install all sub-packages
+Libtaskotron is a support library for running taskotron tasks. The top level
+libtaskotron package is a meta-package which will install all sub-packages.
 
 %package -n libtaskotron-core
 Summary:        The minimal, core parts of libtaskotron
 
 Requires:       libtaskotron-config = %{version}-%{release}
 Requires:       python-configparser >= 3.5.0b2
 Requires:       python-jinja2 >= 2.8
 Requires:       python-progressbar >= 2.3
+Requires:       python-resultsdb_api >= 1.2.1
 Requires:       python-requests >= 2.7.0
 Requires:       python-setuptools
 Requires:       python2-xunitparser >= 1.3.3
 Requires:       PyYAML >= 3.11
-Requires:       resultsdb_api >= 1.2.1
 BuildRequires:  pytest >= 2.7.3
+BuildRequires:  python2-devel
 BuildRequires:  python-configparser >= 3.5.0b2
-BuildRequires:  python-devel
 BuildRequires:  python-dingus >= 0.3.4
 BuildRequires:  python-mock >= 1.0.1
 BuildRequires:  python-progressbar >= 2.3
+BuildRequires:  python-resultsdb_api >= 1.2.1
 BuildRequires:  python-requests >= 2.7.0
 BuildRequires:  python-setuptools
 BuildRequires:  PyYAML >= 3.11
-BuildRequires:  resultsdb_api >= 1.2.1
 
 %description -n libtaskotron-core
 The minimal, core parts of libtaskotron that are needed to run tasks
@@ -102,14 +99,14 @@
 %{__python} setup.py build
 
 %install
-rm -rf $RPM_BUILD_ROOT
+rm -rf %{buildroot}
 %{__python} setup.py install -O1 --skip-build --root %{buildroot}
 
 # configuration files
 mkdir -p %{buildroot}%{_sysconfdir}/taskotron/
-install conf/taskotron.yaml.example %{buildroot}%{_sysconfdir}/taskotron/taskotron.yaml
-install conf/namespaces.yaml.example %{buildroot}%{_sysconfdir}/taskotron/namespaces.yaml
-install conf/yumrepoinfo.conf.example %{buildroot}%{_sysconfdir}/taskotron/yumrepoinfo.conf
+install -m 0644 conf/taskotron.yaml.example %{buildroot}%{_sysconfdir}/taskotron/taskotron.yaml
+install -m 0644 conf/namespaces.yaml.example %{buildroot}%{_sysconfdir}/taskotron/namespaces.yaml
+install -m 0644 conf/yumrepoinfo.conf.example %{buildroot}%{_sysconfdir}/taskotron/yumrepoinfo.conf
 
 # log dir
 install -d %{buildroot}/%{_localstatedir}/log/taskotron
@@ -129,17 +126,18 @@
 %files
 
 %files -n libtaskotron-core
-%doc readme.rst LICENSE
-%{python_sitelib}/libtaskotron/*.py*
-%{python_sitelib}/libtaskotron/directives/*.py*
-%{python_sitelib}/libtaskotron/ext/*.py*
-%{python_sitelib}/libtaskotron/report_templates/*.j2
-%{python_sitelib}/*.egg-info
-
-%dir %{python_sitelib}/libtaskotron/ext/fedora
-%dir %{python_sitelib}/libtaskotron/ext
-%dir %{python_sitelib}/libtaskotron/directives
-%dir %{python_sitelib}/libtaskotron/report_templates
+%doc readme.rst
+%license LICENSE
+%{python2_sitelib}/libtaskotron/*.py*
+%{python2_sitelib}/libtaskotron/directives/*.py*
+%{python2_sitelib}/libtaskotron/ext/*.py*
+%{python2_sitelib}/libtaskotron/report_templates/*.j2
+%{python2_sitelib}/*.egg-info
+
+%dir %{python2_sitelib}/libtaskotron/ext/fedora
+%dir %{python2_sitelib}/libtaskotron/ext
+%dir %{python2_sitelib}/libtaskotron/directives
+%dir %{python2_sitelib}/libtaskotron/report_templates
 
 %attr(755, root, root) %{_bindir}/runtask
 
@@ -153,18 +151,25 @@
 %files -n libtaskotron-config
 %dir %{_sysconfdir}/taskotron
 %config(noreplace) %{_sysconfdir}/taskotron/taskotron.yaml
-%config %{_sysconfdir}/taskotron/namespaces.yaml
+%config(noreplace) %{_sysconfdir}/taskotron/namespaces.yaml
 %config %{_sysconfdir}/taskotron/yumrepoinfo.conf
 
 %files -n libtaskotron-fedora
-%dir %{python_sitelib}/libtaskotron/ext/fedora
-%{python_sitelib}/libtaskotron/ext/fedora/*
+%dir %{python2_sitelib}/libtaskotron/ext/fedora
+%{python2_sitelib}/libtaskotron/ext/fedora/*
 
 %files -n libtaskotron-disposable
-%dir %{python_sitelib}/libtaskotron/ext/disposable
-%{python_sitelib}/libtaskotron/ext/disposable/*
+%dir %{python2_sitelib}/libtaskotron/ext/disposable
+%{python2_sitelib}/libtaskotron/ext/disposable/*
 
 %changelog
+* Fri May 27 2016 Martin Krizek <mkrizek@fedoraproject.org> - 0.4.13-3
+- fix download URL for Source0
+- fix conf files permissions
+
+* Thu May 26 2016 Martin Krizek <mkrizek@fedoraproject.org> - 0.4.13-2
+- remove not needed custom python_sitelib macro
+
 * Thu May 26 2016 Martin Krizek <mkrizek@fedoraproject.org> - 0.4.13-1
 - add distgit docs
 - fix progressbar